/*
 * Copyright (C) 1989, Craig E. Kolb
 *
 * This software may be freely copied, modified, and redistributed,
 * provided that this copyright notice is preserved on all copies.
 * 
 * There is no warranty or other guarantee of fitness for this software,
 * it is provided solely "as is".  Bug reports or fixes may be sent
 * to the author, who may or may not act on them as he desires.
 *
 * You may not include this software in a program or other software product
 * without supplying the source, or without informing the end-user that the 
 * source is available for no extra charge.
 *
 * If you modify this software, you should include a notice giving the
 * name of the person performing the modification, the date of modification,
 * and the reason for such modification.
 *
 * $Id: atmosphere.h,v 3.0 89/11/16 20:40:53 craig Exp Locker: craig $
 *
 * $Log:	atmosphere.h,v $
 * Revision 3.0  89/11/16  20:40:53  craig
 * Initial version.
 * 
 */

typedef struct {
	Color color;		/* Fog color */
	double trans;		/* Fog transmissivity */
} Fog;

typedef struct {
	Color color;		/* Mist color */
	Color trans;		/* R, G, B transmissivity */
	double scale, zero;	/* Height scale, start Z */
} Mist;
